using HarmonyLib;
using UnityEngine;

public class CraftPlantSeeds : Mod
{

    public void Start()
    {
		Item_Base[] seedBananaItem = new Item_Base[] { ItemManager.GetItemByName("Seed_Banana") };
		Item_Base[] strawberryItem = new Item_Base[] { ItemManager.GetItemByName("Strawberry") };
		Item_Base[] watermelonItem = new Item_Base[] { ItemManager.GetItemByName("Watermelon") };
		Item_Base[] seedBirchItem = new Item_Base[] { ItemManager.GetItemByName("Seed_Birch") };
		Item_Base[] seedMangoItem = new Item_Base[] { ItemManager.GetItemByName("Seed_Mango") };
		Item_Base[] pineappleItem = new Item_Base[] { ItemManager.GetItemByName("Pineapple") };
		Item_Base[] seedPalmItem = new Item_Base[] { ItemManager.GetItemByName("Seed_Palm") };
		Item_Base[] seedPineItem = new Item_Base[] { ItemManager.GetItemByName("Seed_Pine") };
		Item_Base[] coconutItem = new Item_Base[] { ItemManager.GetItemByName("Coconut") };
		Item_Base[] bananaItem = new Item_Base[] { ItemManager.GetItemByName("Banana") };
		Item_Base[] mangoItem = new Item_Base[] { ItemManager.GetItemByName("Mango") };
		Item_Base[] plankItem = new Item_Base[] { ItemManager.GetItemByName("Plank") };
		
        CreateRecipe(ItemManager.GetItemByName("Seed_Banana"), 2, new CostMultiple(seedBananaItem, 1), new CostMultiple(bananaItem, 5), new CostMultiple(plankItem,4));
        CreateRecipe(ItemManager.GetItemByName("Seed_Strawberry"), 2, new CostMultiple(strawberryItem, 1));
        CreateRecipe(ItemManager.GetItemByName("Seed_Watermelon"), 2, new CostMultiple(watermelonItem, 1));
        CreateRecipe(ItemManager.GetItemByName("Seed_Birch"), 2, new CostMultiple(seedBirchItem, 1), new CostMultiple(plankItem,7));
        CreateRecipe(ItemManager.GetItemByName("Seed_Mango"), 2, new CostMultiple(seedMangoItem, 1), new CostMultiple(mangoItem, 2), new CostMultiple(plankItem,3));
        CreateRecipe(ItemManager.GetItemByName("Seed_Pineapple"), 2, new CostMultiple(pineappleItem, 1));
        CreateRecipe(ItemManager.GetItemByName("Seed_Palm"), 2, new CostMultiple(seedPalmItem, 1), new CostMultiple(coconutItem, 2), new CostMultiple(plankItem,5));
        CreateRecipe(ItemManager.GetItemByName("Seed_Pine"), 2, new CostMultiple(seedPineItem, 1), new CostMultiple(plankItem,7));

        Debug.Log("Mod CraftPlantSeeds has been loaded!");
    }

    public static void CreateRecipe(Item_Base pResultItem, int pAmount, params CostMultiple[] pCosts)
    {
        Traverse.Create(pResultItem.settings_recipe).Field("newCostToCraft").SetValue(pCosts);
        Traverse.Create(pResultItem.settings_recipe).Field("learned").SetValue(true);
        Traverse.Create(pResultItem.settings_recipe).Field("learnedFromBeginning").SetValue(true);
        Traverse.Create(pResultItem.settings_recipe).Field("craftingCategory").SetValue(CraftingCategory.Resources);
        Traverse.Create(pResultItem.settings_recipe).Field("amountToCraft").SetValue(pAmount);

    }

    public void OnModUnload()
    {
        Debug.Log("Mod CraftPlantSeeds has been unloaded!");
        Destroy(gameObject);
    }
}